'******************************************************************************
' Version 1.0
' Copyright (c) 2011, Dave Hein
' See end of file for terms of use.
'******************************************************************************
{{
  This object contains PASM routines that are used to access external memory.
}}
con
  SYS_COMMAND = $12340000
  SYS_LOCKNUM = $12340002
  SYS_PARM    = $12340004

  SYS_EXTMEM_READ   = 17
  SYS_EXTMEM_WRITE  = 18

dat
ExtMemRead              mov     ExtMemCommand, #SYS_EXTMEM_READ
                        jmp     #SystemCall

ExtMemWrite             mov     ExtMemCommand, #SYS_EXTMEM_WRITE

                        'Set up the parameter list in hub RAM
SystemCall              mov     temp, par
                        wrlong  HubAddr, temp
                        add     temp, #4
                        wrlong  ExtMemAddr, temp
                        add     temp, #4
                        wrlong  NumByte, temp

                        'Wait for lock not set
:loop1                  lockset locknum                       wc
        if_c            jmp     #:loop1
        
                        'Write the address of the parmeter list
                        wrlong  par, SysParm
                        
                        'Write the external memory command
                        wrword  ExtMemCommand, SysCommand
                        
                        'Wait for the command to be completed
:loop2                  rdword  ExtMemCommand, SysCommand     wz
        if_nz           jmp     #:loop2
        
                        'Clear the lock
                        lockclr locknum
ExtMemRead_ret
ExtMemWrite_ret         ret                     

HubAddr                 long    0
ExtMemAddr              long    0
NumByte                 long    0
ExtMemCommand           long    0
locknum                 long    0
temp                    long    
SysCommand              long    SYS_COMMAND
SysLocknum              long    SYS_LOCKNUM
SysParm                 long    SYS_PARM

pub dummy
{{
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  |
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    |
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
}}