'******************************************************************************
' Version 1.0
' Copyright (c) 2011, Dave Hein
' See end of file for terms of use.
'******************************************************************************
{{
  This program is used to test external memory.  It prompts for the memory size
  and then fill the memory with random numbers.  It then reads back the memory
  to verify whether it is correct or not.
}}
con
  BASE_ADDR = $20000000
  
obj
  extmem : "extmem"
  ser : "conio"

var
  long buffer[256]

pub main | char, memsize, i
  memsize~
  ser.str(string("Enter the size of the external memory in K-bytes: "))
  repeat
    char := ser.rx
    ser.tx(char)
    if char == 13
      quit
    memsize := (memsize * 10) + char - "0"
  memsize *= 1024
  ifnot extmem.ExtMemAlloc(BASE_ADDR, memsize)
    ser.str(string("Error allocating external memory", 13))
    return
  repeat i from 0 to memsize - 1 step 1024
    FillBuffer(i)
    ifnot extmem.ExtMemWrite(BASE_ADDR + i, @buffer, 1024)
      ser.str(string("Error writing external memory at address $"))
      ser.hex(BASE_ADDR + i, 8)
      ser.tx(13)
      return
  repeat i from 0 to memsize - 1 step 1024
    if extmem.ExtMemRead(BASE_ADDR + i, @buffer, 1024) <> 1024
      ser.str(string("Error reading external memory at address $"))
      ser.hex(BASE_ADDR + i, 8)
      ser.tx(13)
      return
    CheckBuffer(i)
  ser.str(string("Memory test complete.  No errors found", 13))

pub FillBuffer(seed) | i
  repeat i from 0 to 255
    buffer[i] := ?seed

pub CheckBuffer(seed) | i
  repeat i from 0 to 255
    if buffer[i] <> ?seed
      ser.str(string("CheckBuffer error", 13))
      abort
    
{{
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  |
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    |
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
}}
 